Merge branch 'sb/pull-rebase-submodule'
authorJunio C Hamano <gitster@pobox.com>
Mon, 20 Aug 2018 18:33:54 +0000 (11:33 -0700)
committerJunio C Hamano <gitster@pobox.com>
Mon, 20 Aug 2018 18:33:54 +0000 (11:33 -0700)
"git pull --rebase -v" in a repository with a submodule barfed as
an intermediate process did not understand what "-v(erbose)" flag
meant, which has been fixed.

* sb/pull-rebase-submodule:
git-submodule.sh: accept verbose flag in cmd_update to be non-quiet

1  2 
git-submodule.sh
diff --combined git-submodule.sh
index 8b5ad59bdee39eba4fc56b28d6771a291dac55f0,98049acc98a47e414dcd73ec792f7d3d92784905..f7fd80345cd991df4b17c6598d7dd7bd462424c7
@@@ -42,7 -42,6 +42,7 @@@ prefix
  custom_name=
  depth=
  progress=
 +dissociate=
  
  die_if_unmatched ()
  {
@@@ -118,9 -117,6 +118,9 @@@ cmd_add(
                -q|--quiet)
                        GIT_QUIET=1
                        ;;
 +              --progress)
 +                      progress=1
 +                      ;;
                --reference)
                        case "$2" in '') usage ;; esac
                        reference_path=$2
                --reference=*)
                        reference_path="${1#--reference=}"
                        ;;
 +              --dissociate)
 +                      dissociate=1
 +                      ;;
                --name)
                        case "$2" in '') usage ;; esac
                        custom_name=$2
                die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
        fi
  
 -      if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
 +      if test -z "$force" &&
 +              ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
        then
                eval_gettextln "The following path is ignored by one of your .gitignore files:
  \$sm_path
@@@ -236,11 -228,6 +236,11 @@@ Use -f if you really want to add it." >
                sm_name="$sm_path"
        fi
  
 +      if ! git submodule--helper check-name "$sm_name"
 +      then
 +              die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
 +      fi
 +
        # perhaps the path exists and is already a git repo, else clone it
        if test -e "$sm_path"
        then
@@@ -267,7 -254,7 +267,7 @@@ or you are unsure what this means choos
                                eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
                        fi
                fi
 -              git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
 +              git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
                (
                        sanitize_submodule_env
                        cd "$sm_path" &&
        fi
        git config submodule."$sm_name".url "$realrepo"
  
 -      git add $force "$sm_path" ||
 +      git add --no-warn-embedded-repo $force "$sm_path" ||
        die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
  
        git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
@@@ -335,7 -322,45 +335,7 @@@ cmd_foreach(
                shift
        done
  
 -      toplevel=$(pwd)
 -
 -      # dup stdin so that it can be restored when running the external
 -      # command in the subshell (and a recursive call to this function)
 -      exec 3<&0
 -
 -      {
 -              git submodule--helper list --prefix "$wt_prefix" ||
 -              echo "#unmatched" $?
 -      } |
 -      while read -r mode sha1 stage sm_path
 -      do
 -              die_if_unmatched "$mode" "$sha1"
 -              if test -e "$sm_path"/.git
 -              then
 -                      displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
 -                      say "$(eval_gettext "Entering '\$displaypath'")"
 -                      name=$(git submodule--helper name "$sm_path")
 -                      (
 -                              prefix="$prefix$sm_path/"
 -                              sanitize_submodule_env
 -                              cd "$sm_path" &&
 -                              sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
 -                              # we make $path available to scripts ...
 -                              path=$sm_path &&
 -                              if test $# -eq 1
 -                              then
 -                                      eval "$1"
 -                              else
 -                                      "$@"
 -                              fi &&
 -                              if test -n "$recursive"
 -                              then
 -                                      cmd_foreach "--recursive" "$@"
 -                              fi
 -                      ) <&3 3<&- ||
 -                      die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
 -              fi
 -      done
 +      git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
  }
  
  #
@@@ -402,7 -427,60 +402,7 @@@ cmd_deinit(
                shift
        done
  
 -      if test -n "$deinit_all" && test "$#" -ne 0
 -      then
 -              echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
 -              usage
 -      fi
 -      if test $# = 0 && test -z "$deinit_all"
 -      then
 -              die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
 -      fi
 -
 -      {
 -              git submodule--helper list --prefix "$wt_prefix" "$@" ||
 -              echo "#unmatched" $?
 -      } |
 -      while read -r mode sha1 stage sm_path
 -      do
 -              die_if_unmatched "$mode" "$sha1"
 -              name=$(git submodule--helper name "$sm_path") || exit
 -
 -              displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
 -
 -              # Remove the submodule work tree (unless the user already did it)
 -              if test -d "$sm_path"
 -              then
 -                      # Protect submodules containing a .git directory
 -                      if test -d "$sm_path/.git"
 -                      then
 -                              die "$(eval_gettext "\
 -Submodule work tree '\$displaypath' contains a .git directory
 -(use 'rm -rf' if you really want to remove it including all of its history)")"
 -                      fi
 -
 -                      if test -z "$force"
 -                      then
 -                              git rm -qn "$sm_path" ||
 -                              die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
 -                      fi
 -                      rm -rf "$sm_path" &&
 -                      say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
 -                      say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
 -              fi
 -
 -              mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
 -
 -              # Remove the .git/config entries (unless the user already did it)
 -              if test -n "$(git config --get-regexp submodule."$name\.")"
 -              then
 -                      # Remove the whole section so we have a clean state when
 -                      # the user later decides to init this submodule again
 -                      url=$(git config submodule."$name".url)
 -                      git config --remove-section submodule."$name" 2>/dev/null &&
 -                      say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
 -              fi
 -      done
 +      git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
  }
  
  is_tip_reachable () (
@@@ -438,8 -516,11 +438,11 @@@ cmd_update(
                -q|--quiet)
                        GIT_QUIET=1
                        ;;
+               -v)
+                       GIT_QUIET=0
+                       ;;
                --progress)
 -                      progress="--progress"
 +                      progress=1
                        ;;
                -i|--init)
                        init=1
                --reference=*)
                        reference="$1"
                        ;;
 +              --dissociate)
 +                      dissociate=1
 +                      ;;
                -m|--merge)
                        update="merge"
                        ;;
  
        {
        git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
 -              ${progress:+"$progress"} \
 +              ${progress:+"--progress"} \
                ${wt_prefix:+--prefix "$wt_prefix"} \
                ${prefix:+--recursive-prefix "$prefix"} \
                ${update:+--update "$update"} \
                ${reference:+"$reference"} \
 +              ${dissociate:+"--dissociate"} \
                ${depth:+--depth "$depth"} \
 -              ${recommend_shallow:+"$recommend_shallow"} \
 -              ${jobs:+$jobs} \
 +              $recommend_shallow \
 +              $jobs \
                "$@" || echo "#unmatched" $?
        } | {
        err=
                die_if_unmatched "$mode" "$sha1"
  
                name=$(git submodule--helper name "$sm_path") || exit
 -              url=$(git config submodule."$name".url)
                if ! test -z "$update"
                then
                        update_module=$update
                        die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
                fi
  
 +              if ! $(git config -f "$(git rev-parse --git-common-dir)/modules/$name/config" core.worktree) 2>/dev/null
 +              then
 +                      git submodule--helper connect-gitdir-workingtree "$name" "$sm_path"
 +              fi
 +
                if test "$subsha1" != "$sha1" || test -n "$force"
                then
                        subforce=$force
                                # is not reachable from a ref.
                                is_tip_reachable "$sm_path" "$sha1" ||
                                fetch_in_submodule "$sm_path" $depth ||
 -                              die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
 +                              say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
  
                                # Now we tried the usual fetch, but $sha1 may
                                # not be reachable from any of the refs
        }
  }
  
 -set_name_rev () {
 -      revname=$( (
 -              sanitize_submodule_env
 -              cd "$1" && {
 -                      git describe "$2" 2>/dev/null ||
 -                      git describe --tags "$2" 2>/dev/null ||
 -                      git describe --contains "$2" 2>/dev/null ||
 -                      git describe --all --always "$2"
 -              }
 -      ) )
 -      test -z "$revname" || revname=" ($revname)"
 -}
  #
  # Show commit summary for submodules in index or working tree
  #
@@@ -781,7 -866,7 +784,7 @@@ cmd_summary() 
                                test $status != A && test $ignore_config = all && continue
                        fi
                        # Also show added or modified modules which are checked out
 -                      GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 +                      GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
                        printf '%s\n' "$sm_path"
                done
        )
                missing_dst=
  
                test $mod_src = 160000 &&
 -              ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
 +              ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
                missing_src=t
  
                test $mod_dst = 160000 &&
 -              ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
 +              ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
                missing_dst=t
  
                display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
@@@ -934,7 -1019,54 +937,7 @@@ cmd_status(
                shift
        done
  
 -      {
 -              git submodule--helper list --prefix "$wt_prefix" "$@" ||
 -              echo "#unmatched" $?
 -      } |
 -      while read -r mode sha1 stage sm_path
 -      do
 -              die_if_unmatched "$mode" "$sha1"
 -              name=$(git submodule--helper name "$sm_path") || exit
 -              displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
 -              if test "$stage" = U
 -              then
 -                      say "U$sha1 $displaypath"
 -                      continue
 -              fi
 -              if ! git submodule--helper is-active "$sm_path" ||
 -              {
 -                      ! test -d "$sm_path"/.git &&
 -                      ! test -f "$sm_path"/.git
 -              }
 -              then
 -                      say "-$sha1 $displaypath"
 -                      continue;
 -              fi
 -              if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
 -              then
 -                      set_name_rev "$sm_path" "$sha1"
 -                      say " $sha1 $displaypath$revname"
 -              else
 -                      if test -z "$cached"
 -                      then
 -                              sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
 -                      fi
 -                      set_name_rev "$sm_path" "$sha1"
 -                      say "+$sha1 $displaypath$revname"
 -              fi
 -
 -              if test -n "$recursive"
 -              then
 -                      (
 -                              prefix="$displaypath/"
 -                              sanitize_submodule_env
 -                              wt_prefix=
 -                              cd "$sm_path" &&
 -                              eval cmd_status
 -                      ) ||
 -                      die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
 -              fi
 -      done
 +      git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
  }
  #
  # Sync remote urls for submodules
@@@ -966,8 -1098,63 +969,8 @@@ cmd_sync(
                        ;;
                esac
        done
 -      cd_to_toplevel
 -      {
 -              git submodule--helper list --prefix "$wt_prefix" "$@" ||
 -              echo "#unmatched" $?
 -      } |
 -      while read -r mode sha1 stage sm_path
 -      do
 -              die_if_unmatched "$mode" "$sha1"
 -
 -              # skip inactive submodules
 -              if ! git submodule--helper is-active "$sm_path"
 -              then
 -                      continue
 -              fi
 -
 -              name=$(git submodule--helper name "$sm_path")
 -              url=$(git config -f .gitmodules --get submodule."$name".url)
 -
 -              # Possibly a url relative to parent
 -              case "$url" in
 -              ./*|../*)
 -                      # rewrite foo/bar as ../.. to find path from
 -                      # submodule work tree to superproject work tree
 -                      up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
 -                      # guarantee a trailing /
 -                      up_path=${up_path%/}/ &&
 -                      # path from submodule work tree to submodule origin repo
 -                      sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
 -                      # path from superproject work tree to submodule origin repo
 -                      super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
 -                      ;;
 -              *)
 -                      sub_origin_url="$url"
 -                      super_config_url="$url"
 -                      ;;
 -              esac
 -
 -              displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
 -              say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
 -              git config submodule."$name".url "$super_config_url"
 -
 -              if test -e "$sm_path"/.git
 -              then
 -              (
 -                      sanitize_submodule_env
 -                      cd "$sm_path"
 -                      remote=$(get_default_remote)
 -                      git config remote."$remote".url "$sub_origin_url"
  
 -                      if test -n "$recursive"
 -                      then
 -                              prefix="$prefix$sm_path/"
 -                              eval cmd_sync
 -                      fi
 -              )
 -              fi
 -      done
 +      git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
  }
  
  cmd_absorbgitdirs()